﻿@page "/curator/invites"
@using Microsoft.Extensions.Localization
@using OWebApplication.Operators
@using Microsoft.EntityFrameworkCore
@using System.Threading
@using Overtest.SharedLibraries.Common

@inject AuthenticationStateProvider _authenticationStateProvider
@inject IDbContextFactory<OvertestDatabaseContext> _dbContextFactory
@inject IStringLocalizer<CuratorInvites> _localizer
@inject NavigationManager _navigationManager
@inject UserAccessControlOperator _userAccessControlOperator
@inject UserManager<User> _userManager

@inject IDialogService _dialogService
@inject ISnackbar _snackbar

<MudContainer MaxWidth="MaxWidth.Large" Class="my-3">
    <MudText Typo="Typo.h5" Style="font-weight: bold;">@_localizer["Запрошувальні посилання"]</MudText>
    <MudToolBar Class="px-0 mt-3">
        <MudIconButton Icon="@Icons.Material.Outlined.Add" OnClick="@(async () => await OpenUpdateInviteCodePreferencesModalAsync(false))" />
        @if (_selectedInviteCodes is not null && _selectedInviteCodes.Count > 0)
        {
            if (_selectedInviteCodes.Count == 1)
            {
                <MudIconButton Icon="@Icons.Material.Outlined.Edit" OnClick="@(async () => await OpenUpdateInviteCodePreferencesModalAsync(true))" />
            }
            <MudIconButton Icon="@Icons.Material.Outlined.Delete" OnClick="DeleteSelectedItemsAsync" />
        }
        <MudSpacer />
        <MudIconButton Icon="@Icons.Material.Outlined.MoreVert" Disabled="true" />
    </MudToolBar>
</MudContainer>

<MudContainer MaxWidth="MaxWidth.Large" Class="my-3">
    @if (_inviteCodes is null)
    {
        <MudSkeleton SkeletonType="SkeletonType.Rectangle" Width="100%" Height="300px" />
    }
    else if (_inviteCodes.Count <= 0)
    {
        <MudAlert Severity="Severity.Info" Elevation="0">
            @_localizer["Ви ще не створили жодного коду запрошення для своїх студентів. Створіть перше запрошення вже зараз!"]
        </MudAlert>
    }
    else
    {
        <MudTable MultiSelection="true" Hover="true" Items="@_inviteCodes" @bind-SelectedItems="_selectedInviteCodes">
            <HeaderContent>
                <MudTh>@_localizer["Код запрошення"]</MudTh>
                <MudTh>@_localizer["Статус"]</MudTh>
                <MudTh>@_localizer["Початок дії"]</MudTh>
                <MudTh>@_localizer["Закінчення дії"]</MudTh>
            </HeaderContent>
            <RowTemplate>
                <MudTd DataLabel="@_localizer["Код запрошення:"]">@context.Code</MudTd>
                <MudTd DataLabel="@_localizer["Статус:"]">
                    @if (context.Enabled || ((context.AutoEnableStart is not null && context.AutoEnableEnd is not null)
                                             && (context.AutoEnableStart <= DateTime.UtcNow && context.AutoEnableEnd > DateTime.UtcNow)))
                    {
                        <MudChip Color="Color.Success">@_localizer["Активний"]</MudChip>
                    }
                    else
                    {
                        <MudChip>@_localizer["Неактивний"]</MudChip>
                    }
                </MudTd>
                <MudTd DataLabel="@_localizer["Активно з:"]">@(context.AutoEnableStart?.ToString() ?? _localizer["Не застосовується"])</MudTd>
                <MudTd DataLabel="@_localizer["Активно по:"]">@(context.AutoEnableEnd?.ToString() ?? _localizer["Не застосовується"])</MudTd>
            </RowTemplate>
            <FooterContent>
                <MudTd colspan="4">@_localizer["Обрати усі коди"]</MudTd>
            </FooterContent>
        </MudTable>
    }
</MudContainer>

<MudDialog @bind-IsVisible="_editModalVisible">
    <TitleContent>
        <MudText Typo="Typo.h6">
            @if (_editModel.Id is null)
            {
                @(_localizer["Створення нового запрошення"])
            }
            else
            {
                @(_localizer["Редагування параметрів запрошення"])
            }
        </MudText>
    </TitleContent>
    <DialogContent>
        @if (!string.IsNullOrEmpty(_editModel.Code))
        {
            <MudTextField @bind-Value="_editModel.Code" Label="@_localizer["Код запрошення"]" 
                          ariant="Variant.Text" ReadOnly="true"></MudTextField>
        }
        <MudCheckBox @bind-Checked="_editModel.Enabled" Label="@_localizer["Посилання є завжди активним"]"></MudCheckBox>
        <MudDateRangePicker @bind-DateRange="_editModel.AutoEnableRange" Label="@_localizer["Автоматична активація"]"
                            Disabled="@(_editModel.Enabled)"/>
    </DialogContent>
    <DialogActions>
        <MudButton Variant="Variant.Filled" Color="Color.Primary" Class="px-10"
                   OnClick="UpdateInviteCodePreferencesAsync">@_localizer["Зберегти зміни"]</MudButton>
    </DialogActions>
</MudDialog>

@code {
    private Guid? _currentUserId;
    
    private List<InviteCode> _inviteCodes;
    private HashSet<InviteCode> _selectedInviteCodes;

    private bool _editModalVisible;
    private InviteCodeEditModel _editModel;
    private SemaphoreSlim _editModalSemaphore;

    private SemaphoreSlim _semaphore;
    
    protected override async Task OnInitializedAsync()
    {
        await base.OnInitializedAsync();
        
        var authState = await _authenticationStateProvider.GetAuthenticationStateAsync();
        _currentUserId = new Guid(_userManager.GetUserId(authState.User));

        await using var databaseContext = _dbContextFactory.CreateDbContext();

        var hasCuratorPrivilleges = await _userAccessControlOperator.HasUserTypeAsync(databaseContext,
            _currentUserId.GetValueOrDefault(), UserType.Curator, UserType.SuperUser);

        _inviteCodes = null;
        _selectedInviteCodes = null;

        _editModalVisible = false;
        _editModel = null;
        _editModalSemaphore = new SemaphoreSlim(1, 1);
        
        if (!hasCuratorPrivilleges)
        {
            _snackbar.Add(_localizer["Ви не маєте необхідних прав для доступу до цього сервісу!"],
                Severity.Error, options => options.CloseAfterNavigation = false);
            _navigationManager.NavigateTo("/");
            return;
        }
        
        _semaphore = new SemaphoreSlim(1, 1);
    }

    protected override async Task OnAfterRenderAsync(bool firstRender)
    {
        await base.OnAfterRenderAsync(firstRender);

        if (!firstRender)
            return;
        
        await UpdateInviteCodesListAsync();
        StateHasChanged();
    }

    private async Task UpdateInviteCodesListAsync()
    {
        await _semaphore.WaitAsync();
        
        await using var databaseContext = _dbContextFactory.CreateDbContext();

        _inviteCodes = await databaseContext.InviteCodes
            .Where(c => c.CuratorId == _currentUserId)
            .OrderByDescending(order => order.AutoEnableEnd)
            .ThenByDescending(order => order.AutoEnableStart)
            .ThenByDescending(order => order.Enabled)
            .AsNoTracking().ToListAsync();

        _semaphore.Release();
    }

    private async Task OpenUpdateInviteCodePreferencesModalAsync(bool editSelected)
    {
        await using var databaseContext = _dbContextFactory.CreateDbContext();

        if (editSelected)
        {
            var selectedItem = _selectedInviteCodes.First();
            _editModel = new InviteCodeEditModel
            {
                Id = selectedItem.Id,
                Code = selectedItem.Code,
                Enabled = selectedItem.Enabled,
                AutoEnableRange = new DateRange(selectedItem.AutoEnableStart, selectedItem.AutoEnableEnd)
            };
        }
        else
        {
            _editModel = new InviteCodeEditModel
            {
                Id = null,
                Code = null,
                Enabled = true,
                AutoEnableRange = new DateRange(null, null)
            };
        }
        _editModalVisible = true;
    }
    
    private async Task UpdateInviteCodePreferencesAsync()
    {
        await _editModalSemaphore.WaitAsync();
        _editModalVisible = false;
        
        await using var databaseContext = _dbContextFactory.CreateDbContext();
        InviteCode inviteCodeObject;
        var alreadyExists = false;

        if (_editModel.Id is not null)
        {
            if (!await databaseContext.InviteCodes.AnyAsync(c => c.Id == _editModel.Id && c.CuratorId == _currentUserId))
            {
                _editModel = null;
                _editModalSemaphore.Release();
                return;
            }

            inviteCodeObject = await databaseContext.InviteCodes.AsNoTracking().FirstAsync(c => c.Id == _editModel.Id);
            alreadyExists = true;
        }
        else { inviteCodeObject = new InviteCode(); }

        inviteCodeObject.Enabled = _editModel.Enabled;
        inviteCodeObject.CuratorId = _currentUserId.GetValueOrDefault();

        if (_editModel.Enabled)
        {
            inviteCodeObject.AutoEnableStart = inviteCodeObject.AutoEnableEnd = null;
        }
        else if (_editModel.AutoEnableRange.Start is not null && _editModel.AutoEnableRange.End is not null)
        {
            var start = _editModel.AutoEnableRange.Start.GetValueOrDefault();
            var end = _editModel.AutoEnableRange.End.GetValueOrDefault().Add(new TimeSpan(23, 59, 59));
            
            inviteCodeObject.AutoEnableStart = start;
            inviteCodeObject.AutoEnableEnd = end;
        }
        else
        {
            inviteCodeObject.AutoEnableStart = inviteCodeObject.AutoEnableEnd = null;
            inviteCodeObject.Enabled = false;
        }
        
        if (alreadyExists)
        {
            databaseContext.InviteCodes.Update(inviteCodeObject);
        }
        else
        {
            inviteCodeObject.Code = GuidAccessToken.Generate();
            await databaseContext.InviteCodes.AddAsync(inviteCodeObject);
        }
        
        await databaseContext.SaveChangesAsync();
        _editModalSemaphore.Release();

        _snackbar.Add(_localizer["Зміни успішно збережено!"], Severity.Success);

        _selectedInviteCodes = null;
        await UpdateInviteCodesListAsync();
        StateHasChanged();
    }
    
    private async Task DeleteSelectedItemsAsync()
    {
        await _semaphore.WaitAsync();

        try
        {
            var confirmation = await _dialogService.ShowMessageBox(
                _localizer["Видалення запрошувальних кодів"],
                _localizer["Ви впевнені, що хочете видалити обрані коди запрошення нових користувачів до системи? Ця дія є безповоротною!"],
                yesText: _localizer["Видалити"], cancelText: _localizer["Відмінити"]);

            if (confirmation is null or false)
            {
                _selectedInviteCodes = null;
                return;
            }

            await using var databaseContext = _dbContextFactory.CreateDbContext();
            databaseContext.InviteCodes.RemoveRange(_selectedInviteCodes);
            await databaseContext.SaveChangesAsync();
        }
        finally
        {
            _semaphore.Release();
        }
        
        _selectedInviteCodes = null;
        await UpdateInviteCodesListAsync();
        StateHasChanged();
    }
    
    private sealed class InviteCodeEditModel
    {
        // ReSharper disable once PropertyCanBeMadeInitOnly.Local
        public Guid? Id { get; set; }
        
        public string Code { get; set; }
        
        public bool Enabled { get; set; }
        
        public DateRange AutoEnableRange { get; set; }
    }
}